//////////////////////////////////////////////////////////
// Sketch library for HC-SR04 (manufacturer unknown)
// Header file.
// Programmed by KEI SAKAKI. http://kei-sakaki.jp/

#ifndef INCLUDED_KEI_SAKAKI_HC_SR04
#define INCLUDED_KEI_SAKAKI_HC_SR04

#if (ARDUINO >= 100)
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

class HC_SR04 {
  protected:
    int TirggerPin;
    int EchoPin;
    int MinDuration;
    int MaxDuration;
    float Temperature;
    float SoundSpeed;
    float LastDistance;
  public:
    enum {
      MIN_ECHO_DURATION = 1,
      MAX_ECHO_DURATION = 38000
    };
  
    HC_SR04(int TirggerPin, int EchoPin);
    virtual ~HC_SR04();
    virtual void setDurationRange(int max = MAX_ECHO_DURATION, int min = MIN_ECHO_DURATION);
    virtual float getDistance(bool inch = false);
    virtual float getLastDistance(bool inch = false);
    virtual void setTemperature(float Temperature);
    virtual float getTemperature();
    virtual void setSoundSpeed(float SoundSpeed);
    virtual float getSoundSpeed();
};

#endif
